/***************************************************************************
                          cconfig.cpp  -  description
                             -------------------
    begin                : Tue May 14 2002
    copyright            : (C) 2002-2003 by Mathias Kster
    email                : mathen@ketelhot.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define DCLIB_CONFIG		"dclib.cfg"
#define DCTRA_CONFIG		"dctra.cfg"
#define DCHUB_CONFIG		"dchub.cfg"
#define DCPROF_CONFIG		"dcprof.cfg"
#define DCBOOKHUB_CONFIG	"dcbookhub.cfg"
#define DCSHARE_CONFIG		"dcshare.cfg"

#define XML_DCLIB_CONFIG	"dclib"
#define XML_DCHUB_CONFIG	"dchub"
#define XML_DCBOOKHUB_CONFIG	"dcbookhub"
#define XML_DCTRA_CONFIG	"dctra"
#define XML_DCSHARE_CONFIG	"dcshare"
#define XML_DCPROF_CONFIG	"dcprof"

#define XML_IDENTIFY		"identify"
#define XML_NICK		"nick"
#define XML_SEARCHNICK		"searchnick"
#define XML_AWAYMESSAGE		"awaymessage"
#define XML_EMAIL		"email"
#define XML_ANTISPAM		"antispam"
#define XML_DESCRIPTION		"description"
#define XML_SPEED		"speed"
#define XML_DESCRIPTION_TAG	"descriptiontag"

#define XML_LOGFILE		"logfile"
#define XML_LOGFILEON		"logfileon"
#define XML_LOGFILENAME		"logfilename"

#define XML_SECURITY		"security"
#define XML_FLOODOPKICKMESSAGE	"floodopkickmessage"

#define XML_TRANSFER		"transfer"
#define XML_DOWNLOADFOLDER	"downloadfolder"
#define XML_DOWNLOADFINISHEDFOLDER	"downloadfinishedfolder"
#define XML_SHAREDFOLDER	"sharedfolder"
#define XML_MAXUPLOAD		"maxupload"
#define XML_MAXUPLOADRATE	"maxuploadrate"
#define XML_MAXDOWNLOADRATE	"maxdownloadrate"
#define XML_AUTORECREATESHARELIST	"autorecreatesharelist"
#define XML_SENDMESSAGEONACTIVEMODEREQUEST "sendmessageonactivemoderequest"

#define XML_CONNECTION		"connection"
#define XML_MODE		"mode"
#define XML_TCPLISTENPORT	"tcplistenport"
#define XML_UDPLISTENPORT	"udplistenport"
#define XML_IP			"ip"
#define XML_CHANGEIP		"changeip"
#define XML_INTERFACE		"interface"

#define XML_SERVER		"server"
#define XML_HOST		"host"
#define XML_BOOKMARK		"bookmark"
#define XML_PUBLIC		"public"
#define XML_NAME		"name"
#define XML_USERCOUNT		"usercount"
#define XML_PROFILE_NAME	"profilename"
#define XML_PROFILE		"profile"
#define XML_PASSWORD		"password"
#define XML_AUTO_CONNECT	"autoconnect"

#define XML_FILE		"file"
#define XML_FILEENTRY		"fileentry"
#define XML_TYPE		"type"
#define XML_PATH		"path"
#define XML_ATIME		"atime"
#define XML_CTIME		"ctime"
#define XML_MTIME		"mtime"
#define XML_LOCALFILE		"localfile"
#define XML_LOCALPATH		"localpath"
#define XML_LOCALFILENAME	"localfilename"
#define XML_SIZE		"size"
#define XML_PRIORITY		"priority"
#define XML_REMOTEFILE		"remotefile"
#define XML_MEDIUM		"medium"
#define XML_MEDIUM_FILE		"file"
#define XML_MEDIUM_BUFFER	"buffer"

#define XML_FILECHUNK		"filechunk"
#define XML_REFCOUNT		"refcount"
#define XML_CHUNK		"chunk"
#define XML_TEMPHASH		"temphash"
#define XML_MD5HASH		"md5hash"
#define XML_MD4HASH		"md4hash"
#define XML_MD4HASHLIST		"md4hashlist"

#define XML_SIZEDONE		"sizedone"
#define XML_MULTI		"multi"

#define XML_START		"start"
#define XML_END			"end"

#define XML_HUB			"hub"
#define XML_ACTIVE		"active"
#define XML_HUBNAME		"hubname"
#define XML_HUBHOST		"hubhost"
#define XML_REMOTEHOST		"remotehost"

#define XML_HUBLISTURL		"hublisturl"
#define XML_URL			"url"
#define XML_ENABLED		"enabled"

#define XML_OTHER			"other"
#define XML_HUBLISTSTORELOCAL		"hubliststorelocal"
#define XML_RECONNECTCOUNT		"reconnectcount"
#define XML_RECONNECTTIMEOUT		"reconnecttimeout"
#define XML_TRANSFERRESPONSETIMEOUT 	"transferresponsetimeout"
#define XML_TRANSFERRESENDTIMEOUT 	"transferresendtimeout"
#define XML_FORCEMOVEENABLED		"forcemoveenabled"
#define XML_DOWNLOADQUEUETIME		"downloadqueuetime"
#define XML_CHECKPRIVATEADDRESSSPACE	"checkprivateaddressspace"

#define XML_SEARCH_HISTORY		"searchhistory"
#define XML_DATADIR			"datadir"
#define XML_DYNAMICUPLOADRATE		"dynamicuploadrate"

#define XML_CHATSENDOFFLINEMESSAGES	"chatsendofflinemessages"
#define XML_CHATRECVOFFLINEMESSAGES	"chatrecvofflinemessages"

#define XML_DC				"dc"
#define XML_VERSION			"version"
#define XML_RELEASE			"release"

#define XML_MODE_ACTIVE			"active"
#define XML_MODE_PASSIVE		"passive"

#define XML_USER_UPLOAD_SLOTS		"useruploadslots"
#define XML_TRANSFER_CERT		"transfercert"
#define XML_TRANSFER_KEY		"transferkey"

#define XML_HUBOFFLINE_TRANSFERCLOSE	"hubofflinetransferclose"

#ifdef WIN32
#define DCGUI_CONFIG_PATH	"/dc"
#else
#define DCGUI_CONFIG_PATH	"/.dc"
#endif

#include <stdlib.h>

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <dclib/dcos.h>
#include <dclib/che3.h>
#include <dclib/cbz.h>
#include <dclib/cxml.h>
#include <dclib/cdir.h>
#include <dclib/csocket.h>
#include <dclib/dcobject.h>
#include <dclib/cquerymanager.h>
#include <dclib/cfilemanager.h>
#include <dclib/cstringlist.h>
#include <dclib/cservermanager.h>
#include <dclib/cdownloadmanager.h>
#include <dclib/cdownloadqueue.h>

#include "cconfig.h"

/** default hub url list */
const char * huburl_list[] = {
	"http://www.neo-modus.com/PublicHubList.config",
	"http://dcplusplus.sourceforge.net/PublicHubList.config",
	"http://axljab.homelinux.org:8080/PublicHubList.config.bz2",
	"http://dreamland.gotdns.org/PublicHubList.config",
	"http://dc-dreamland.dhs.org/PublicHubList.config",
	"http://web.njit.edu/~cjm3//PublicHubList.config",
	0	   
};
/** */
CConfig::CConfig( CString configpath )
{
	CDir d;

	if ( configpath == "" )
	{
		sConfigPath = CDir::HomeDirPath();
		d.SetPath(sConfigPath);
		d.CreatePath(DCGUI_CONFIG_PATH);
		sConfigPath += DCGUI_CONFIG_PATH;
	}
	else
	{
		sConfigPath = configpath;
	}

	sConfigPath += DIRSEPARATOR;

	// default settings
	sEMail       = "email";
	sNick        = "nick";
	sSearchNick  = "nick_search";
	sAwayMessage = "";
	sDescription = "dc-gui user (http://dc.ketelhot.de)";
	sSpeed       = "";
	sHost        = "";
	sInterface   = "ppp0";

	eMode     = ecmPassive;
	eAwayMode = euamNORMAL;

	iTCPListenPort     = 9176;
	iUDPListenPort     = 9176;
	iFakeHost          = 0;
	iMaxUpload         = 3;
	lMaxUploadRate     = 0;
	iUserUploadSlots   = 1;
	lMaxDownloadRate   = 0;
	iDownloadQueueTime = 0;
	iReconnectCount    = 3;
	iReconnectTimeout  = 60;

	bSendMessageOnActiveModeRequest = FALSE;
	bHubListStoreLocal              = TRUE;
	bForceMoveEnabled               = TRUE;
	bAntiSpam                       = TRUE;
	bDescriptionTag                 = FALSE;
	bCheckPrivateAddressSpace       = FALSE;
	bDynamicUploadRate              = TRUE;
	bChatSendOfflineMessages 	= FALSE;
	bChatRecvOfflineMessages 	= TRUE;

	iTransferResendTimeout   = 100;
	iTransferResponseTimeout = 60;
	eHubOfflineTransferClose = ectNONE;
	
	sDownloadFolder         = "";
	sDownloadFinishedFolder = "";

	bAutoRecreateShareList = FALSE;

	bLogFile = 0;
	sLogFile = "";

	iShareSize   = 0;
	m_pHE3ShareBuffer = 0;
	m_pBZShareBuffer = 0;

	pBookmarkHubList = new CStringList();
	pPublicHubList   = new CStringList();
	pHubProfileList  = new CStringList();
	pSearchHistory   = new CList<CString>();

	pPublicHubList_HostIndex = new CStringList();

	sFloodOpKickMessage = "Flooding";

#ifndef WIN32
	sDatadir  = DATADIR;
	sDatadir += "/dcgui";
#else
	sDatadir = "";
#endif
	m_sTransferCert = "";
	m_sTransferKey  = "";

	SetInstance(this);
}

/** */
CConfig::~CConfig()
{
	if ( pPublicHubList )
	{
		delete pPublicHubList;
	}

	if ( pBookmarkHubList )
	{
		delete pBookmarkHubList;
	}

	if ( pHubProfileList )
	{
		delete pHubProfileList;
	}

	if ( pSearchHistory )
	{
		delete pSearchHistory;
	}

	if ( m_pHE3ShareBuffer )
	{
		delete m_pHE3ShareBuffer;
		 m_pHE3ShareBuffer = 0;
	}

	if ( m_pBZShareBuffer )
	{
		delete m_pBZShareBuffer;
		m_pBZShareBuffer = 0;
	}

	if ( pPublicHubList_HostIndex )
	{
		delete pPublicHubList_HostIndex;
		pPublicHubList_HostIndex = 0;
	}
}

/** */
int CConfig::LoadDCMyList()
{
	CDir dir;
	ulonglong size;
	int err = -1;
	FILE * in;
	CString s,s1,*share,slength;
	CHE3 *he3;
	CByteArray ba;
	long i,j,d;

	iShareSize = 0;

	if ( m_pHE3ShareBuffer )
	{
		delete m_pHE3ShareBuffer;
		m_pHE3ShareBuffer = 0;
	}

	if ( m_pBZShareBuffer )
	{
		delete m_pBZShareBuffer;
		m_pBZShareBuffer = 0;
	}

	// load he3 compressed list
	s = sConfigPath + DC_USER_FILELIST_HE3;

	size = dir.getFileSize(s,FALSE);

	if ( size != 0 )
	{
		if ( (in = fopen(s.Data(),"r+b")) != 0 )
		{
			ba.SetSize(size);

			if ( fread( ba.Data(), 1, size, in ) == size )
			{
				m_pHE3ShareBuffer = new CByteArray();
				m_pHE3ShareBuffer->Append(ba.Data(),ba.Size());

				he3 = new CHE3();
				share = he3->decode_he3_data(m_pHE3ShareBuffer);
				delete he3;

				if ( share == 0 )
				{
					delete m_pHE3ShareBuffer;
					m_pHE3ShareBuffer = 0;
				}
				else
				{
					i = j = 0;
					while((i=share->Find("\xD\xA",j))>0)
					{
						s1 = share->Mid(j,i-j);

						if ( s1 != "" )
						{
							d = s1.FindRev('|');
							if ( d != -1 )
							{
								slength = s1.Mid(d+1,s1.Length()-d-1);
								if ( slength != "" )
								{
									iShareSize += CString(slength.Data()).asULL();
								}
							}
						}

						j = i+2;
					}

					if ( iShareSize == 0 )
					{
						delete m_pHE3ShareBuffer;
						m_pHE3ShareBuffer = 0;
					}
					else
					{
						err = 0;
					}

					delete share;
				}
			}

			fclose(in);
		}
	}

	// load bz compressed list
	s = sConfigPath + DC_USER_FILELIST_BZ;

	size = dir.getFileSize(s,FALSE);

	if ( size != 0 )
	{
		if ( (in = fopen(s.Data(),"r+b")) != 0 )
		{
			ba.SetSize(size);

			if ( fread( ba.Data(), 1, size, in ) == size )
			{
				m_pBZShareBuffer = new CByteArray();
				m_pBZShareBuffer->Append(ba.Data(),ba.Size());
			}

			fclose(in);
		}
	}


	if ( CFileManager::Instance() )
	{
		if ( err == -1 )
		{
			CFileManager::Instance()->CreateShareList();
		}
		else
		{
			if ( bAutoRecreateShareList )
			{
				if ( CFileManager::Instance()->GetShareSize() != GetShareSize() )
				{
					// Recreate list if total filesize has changed
					CFileManager::Instance()->CreateShareList();
				}
				else
				{
					CFileManager::Instance()->Lock();
					CFileManager::Instance()->CreateSearchIndex();
					CFileManager::Instance()->UnLock();
				}
			}
			else
			{
				CFileManager::Instance()->Lock();
				CFileManager::Instance()->CreateSearchIndex();
				CFileManager::Instance()->UnLock();
			}
		}
	}

	return err;
}

/** */
int CConfig::SaveDCMyList()
{
	int err = -1;
	FILE * out;
	CString s;

	// save he3 compressed list
	s = sConfigPath + DC_USER_FILELIST_HE3;

	if ( (out = fopen(s.Data(),"wb")) != 0 )
	{
		if ( m_pHE3ShareBuffer )
		{

			if ( fwrite( m_pHE3ShareBuffer->Data(), m_pHE3ShareBuffer->Size(), 1, out ) == (ulonglong)m_pHE3ShareBuffer->Size() )
			{
				err = 0;
			}
		}

		fclose(out);
	}
	else
	{
		printf("[ERROR] open %s\n",s.Data());
	}

	// save bz compressed list
	s = sConfigPath + DC_USER_FILELIST_BZ;

	if ( (out = fopen(s.Data(),"wb")) != 0 )
	{
		if ( m_pBZShareBuffer )
		{
			if ( fwrite( m_pBZShareBuffer->Data(), m_pBZShareBuffer->Size(), 1, out ) == (ulonglong)m_pBZShareBuffer->Size() )
			{
				err = 0;
			}
		}

		fclose(out);
	}
	else
	{
		printf("[ERROR] open %s\n",s.Data());
	}

	return err;
}

/** */
int CConfig::LoadDCLib()
{
	int err = 0;
	CString s;
	CXml * xml;
	xmlNodePtr node;

	s = sConfigPath + DCLIB_CONFIG;

	xml = new CXml();

	if ( xml->ParseFile(s) == TRUE )
	{
		for(node=xml->doc()->children;node!=0;node=node->next)
		{
			if ( xml->name(node) == XML_DCLIB_CONFIG )
			{
				ParseDCLibConfig(node->xmlChildrenNode);
			}
		}
	}
	else
	{
		err = -1;
	}

	// default hublist url
	if ( pHubListUrlList.Count() == 0 )
	{
		DCConfigHubListUrl * hublisturl;
		int i;

		for(i=0;huburl_list[i]!=0;i++)
		{
			hublisturl = new DCConfigHubListUrl();
			hublisturl->sUrl = huburl_list[i];
			hublisturl->bEnabled = TRUE;

			pHubListUrlList.Add(hublisturl);
		}
	}

	delete xml;

	return err;
}

/** */
int CConfig::SaveDCLib()
{
	int err=0;
	CString s;
	CString *ps;
	xmlDocPtr doc;
	xmlNodePtr node,node1;
	CXml * xml;

	xml = new CXml();

	doc = xmlNewDoc((const xmlChar*)"1.0");

	doc->children = xmlNewDocNode(doc,0,(const xmlChar*)XML_DCLIB_CONFIG,0);

	// identify
	node = xmlNewChild( doc->children, 0, (const xmlChar*)XML_IDENTIFY, 0 );

	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_NICK,        sNick );
	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_SEARCHNICK,  sSearchNick );
	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_AWAYMESSAGE, sAwayMessage );
	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_EMAIL,       sEMail );
	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_DESCRIPTION, sDescription );
	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_SPEED,       sSpeed );
	xml->xmlNewBoolChild( node, 0, (const xmlChar*)XML_ANTISPAM, bAntiSpam );
	xml->xmlNewBoolChild( node, 0, (const xmlChar*)XML_DESCRIPTION_TAG, bDescriptionTag );

	// logfile
	node = xmlNewChild( doc->children, 0, (const xmlChar*)XML_LOGFILE, 0 );

	xml->xmlNewBoolChild( node, 0, (const xmlChar*)XML_LOGFILEON, bLogFile );
	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_LOGFILENAME, sLogFile );
	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_FLOODOPKICKMESSAGE, sFloodOpKickMessage);
	
	// transfer
	node = xmlNewChild( doc->children, 0, (const xmlChar*)XML_TRANSFER, 0 );

	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_DOWNLOADFOLDER, sDownloadFolder );
	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_DOWNLOADFINISHEDFOLDER, sDownloadFinishedFolder );

	ps=0;
	while( (ps=SharedFolders.Next(ps)) != 0 )
	{
		xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_SHAREDFOLDER, *ps );
	}

	xml->xmlNewBoolChild( node, 0, (const xmlChar*)XML_AUTORECREATESHARELIST, bAutoRecreateShareList);

	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_MAXUPLOAD, CString().setNum(iMaxUpload) );
	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_USER_UPLOAD_SLOTS, CString().setNum(iUserUploadSlots) );
	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_MAXUPLOADRATE, CString().setNum(lMaxUploadRate) );
	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_MAXDOWNLOADRATE, CString().setNum(lMaxDownloadRate) );
	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_DOWNLOADQUEUETIME, CString().setNum(iDownloadQueueTime) );
	xml->xmlNewBoolChild( node, 0, (const xmlChar*)XML_DYNAMICUPLOADRATE, bDynamicUploadRate );
	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_TRANSFER_CERT, m_sTransferCert );
	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_TRANSFER_KEY, m_sTransferKey );
	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_HUBOFFLINE_TRANSFERCLOSE, CString().setNum(eHubOfflineTransferClose) );
	
	// connection
	node = xmlNewChild( doc->children, 0, (const xmlChar*)XML_CONNECTION, 0 );

	if ( eMode == ecmPassive )
		s = XML_MODE_PASSIVE;
	else
		s = XML_MODE_ACTIVE;
	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_MODE, s.Data() );
	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_TCPLISTENPORT, CString().setNum(iTCPListenPort) );
	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_UDPLISTENPORT, CString().setNum(iUDPListenPort) );
	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_CHANGEIP, CString().setNum(iFakeHost) );
	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_IP, sHost );
	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_INTERFACE, sInterface );
	xml->xmlNewBoolChild( node, 0, (const xmlChar*)XML_SENDMESSAGEONACTIVEMODEREQUEST, bSendMessageOnActiveModeRequest );
	xml->xmlNewBoolChild( node, 0, (const xmlChar*)XML_CHECKPRIVATEADDRESSSPACE, bCheckPrivateAddressSpace );

	// hublisturl
	node = xmlNewChild( doc->children, 0, (const xmlChar*)XML_HUBLISTURL, 0 );

	DCConfigHubListUrl *hublisturl = 0;

	while( (hublisturl=pHubListUrlList.Next(hublisturl)) != 0 )
	{
		node1 = xmlNewChild( node, 0, (const xmlChar*)XML_URL, 0 );
		xml->xmlNewStringChild( node1, 0, (const xmlChar*)XML_NAME, hublisturl->sUrl );
		xml->xmlNewBoolChild( node1, 0, (const xmlChar*)XML_ENABLED, hublisturl->bEnabled );
	}

	// other
	node = xmlNewChild( doc->children, 0, (const xmlChar*)XML_OTHER, 0 );

	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_RECONNECTCOUNT, CString().setNum(iReconnectCount) );
	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_RECONNECTTIMEOUT, CString().setNum(iReconnectTimeout) );
	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_TRANSFERRESPONSETIMEOUT, CString().setNum(iTransferResponseTimeout) );
	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_TRANSFERRESENDTIMEOUT, CString().setNum(iTransferResendTimeout) );
	xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_DATADIR, sDatadir );
	xml->xmlNewBoolChild( node, 0, (const xmlChar*)XML_CHATSENDOFFLINEMESSAGES, bChatSendOfflineMessages );
	xml->xmlNewBoolChild( node, 0, (const xmlChar*)XML_CHATRECVOFFLINEMESSAGES, bChatRecvOfflineMessages );
	xml->xmlNewBoolChild( node, 0, (const xmlChar*)XML_HUBLISTSTORELOCAL, bHubListStoreLocal );
	xml->xmlNewBoolChild( node, 0, (const xmlChar*)XML_FORCEMOVEENABLED, bForceMoveEnabled );

	// search history
	node = xmlNewChild( doc->children, 0, (const xmlChar*)XML_SEARCH_HISTORY, 0 );

	ps = 0;

	while( (ps = pSearchHistory->Next(ps)) != 0 )
	{
		xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_NAME, *ps );
	}

	// save file
	s = sConfigPath + DCLIB_CONFIG;

	if ( xmlSaveFormatFile(s.Data(),doc,1) == -1 )
	{
		err = -1;
	}

	xmlFreeDoc(doc);

	delete xml;

	return err;
}

/** */
int CConfig::LoadDCHub()
{
	CString s;
	CXml * xml;
	xmlNodePtr node;

	// load public hub list
	s = sConfigPath + DCHUB_CONFIG;

	xml = new CXml();

	if ( xml->ParseFile(s) == TRUE )
	{
		for(node=xml->doc()->children;node!=0;node=node->next)
		{
			if ( !xmlStrcmp( node->name, (const xmlChar*)XML_DCHUB_CONFIG ) )
			{
				ParseDCHubConfig(node->xmlChildrenNode);
			}
		}
	}

	delete xml;

	// load bookmark hub list
	s = sConfigPath + DCBOOKHUB_CONFIG;

	xml = new CXml();

	if ( xml->ParseFile(s) == TRUE )
	{
		for(node=xml->doc()->children;node!=0;node=node->next)
		{
			if ( !xmlStrcmp( node->name, (const xmlChar*)XML_DCBOOKHUB_CONFIG ) )
			{
				ParseDCBookHubConfig(node->xmlChildrenNode);
			}
		}
	}

	delete xml;

	return 0;
}

/** */
int CConfig::SaveDCHub()
{
	int err=0;

	SaveDCPublicHub();

	SaveDCBookHub();

	return err;
}

/** */
int CConfig::SaveDCPublicHub()
{
	int err=0;
	CString s;
	xmlDocPtr doc;
	xmlNodePtr node,node1;
	CXml * xml;
	DCConfigHubItem *hubitem;

	xml = new CXml();
	doc = xmlNewDoc((const xmlChar*)"1.0");

	doc->children = xmlNewDocNode(doc,0,(const xmlChar*)XML_DCHUB_CONFIG,0);

	// bookmarks
	node = xmlNewChild( doc->children, 0, (const xmlChar*)XML_SERVER, 0 );

	// store public hub list
	if ( bHubListStoreLocal == TRUE )
	{
		hubitem = 0;

		while( pPublicHubList->Next((CObject*&)hubitem) != 0 )
		{
			node1 = xmlNewChild( node, 0, (const xmlChar*)XML_PUBLIC, 0 );
			xml->xmlNewStringChild( node1, 0, (const xmlChar*)XML_NAME,        hubitem->sName );
			xml->xmlNewStringChild( node1, 0, (const xmlChar*)XML_HOST,        hubitem->sHost );
			xml->xmlNewStringChild( node1, 0, (const xmlChar*)XML_DESCRIPTION, hubitem->sDescription );
			xml->xmlNewStringChild( node1, 0, (const xmlChar*)XML_USERCOUNT,   hubitem->sUserCount );
		}
	}

	// save file
	s = sConfigPath + DCHUB_CONFIG;

	if ( xmlSaveFormatFile(s.Data(),doc,1) == -1 )
	{
		err = -1;
	}

	xmlFreeDoc(doc);

	delete xml;

	return err;
}

/** */
int CConfig::SaveDCBookHub()
{
	int err=0;
	CString s;
	xmlDocPtr doc;
	xmlNodePtr node,node1;
	CXml * xml;
	DCConfigHubItem *hubitem;

	xml = new CXml();
	doc = xmlNewDoc((const xmlChar*)"1.0");

	doc->children = xmlNewDocNode(doc,0,(const xmlChar*)XML_DCBOOKHUB_CONFIG,0);

	// bookmarks
	node = xmlNewChild( doc->children, 0, (const xmlChar*)XML_SERVER, 0 );

	hubitem = 0;

	while( pBookmarkHubList->Next((CObject*&)hubitem) != 0 )
	{
		node1 = xmlNewChild( node, 0, (const xmlChar*)XML_PUBLIC, 0 );
		xml->xmlNewStringChild( node1, 0, (const xmlChar*)XML_NAME,         hubitem->sName );
		xml->xmlNewStringChild( node1, 0, (const xmlChar*)XML_HOST,         hubitem->sHost );
		xml->xmlNewStringChild( node1, 0, (const xmlChar*)XML_DESCRIPTION,  hubitem->sDescription );
		xml->xmlNewStringChild( node1, 0, (const xmlChar*)XML_PROFILE_NAME, hubitem->sProfile );
	}

	// save file
	s = sConfigPath + DCBOOKHUB_CONFIG;

	if ( xmlSaveFormatFile(s.Data(),doc,1) == -1 )
	{
		err = -1;
	}

	xmlFreeDoc(doc);
	delete xml;

	return err;
}

/** */
int CConfig::LoadDCTra( CStringList * queue, CStringList * chunks )
{
	CXml * xml;
	xmlNodePtr node,c1,c2,c3,c4;
	CString s;
	CStringList * sl1,*sl2;
	DCHubObject * HubObject;

	s = sConfigPath + DCTRA_CONFIG;

	xml = new CXml();

	if ( xml->ParseFile(s) == FALSE )
	{
		delete xml;
		return -1;
	}

	for(node=xml->doc()->children;node!=0;node=node->next)
	{
		if ( xml->name(node) == XML_DCTRA_CONFIG )
		{
			for(c1=node->xmlChildrenNode;c1!=0;c1=c1->next)
			{
				if ( xml->name(c1) == XML_TRANSFER )
				{
					DCTransferQueueObject * TransferObject = new DCTransferQueueObject();
					TransferObject->eState = etwsIDLE;
					TransferObject->iConnections = 0;

					for(c2=c1->xmlChildrenNode;c2!=0;c2=c2->next)
					{
						if ( xml->name(c2) == XML_NICK )
							TransferObject->sNick = xml->content(c2);
						else if ( xml->name(c2) == XML_HUBNAME )
							TransferObject->sHubName = xml->content(c2);
						else if ( xml->name(c2) == XML_HUBHOST )
							TransferObject->sHubHost = xml->content(c2);
						else if ( xml->name(c2) == XML_HUB )
						{
							HubObject = new DCHubObject();

							for(c3=c2->xmlChildrenNode;c3!=0;c3=c3->next)
							{
								if ( xml->name(c3) == XML_HUBNAME )
									HubObject->m_sHubName = xml->content(c3);
								else if ( xml->name(c3) == XML_HUBHOST )
									HubObject->m_sHubHost = xml->content(c3);
								if ( xml->name(c3) == XML_ACTIVE )
									HubObject->m_bActive = xml->getBoolChild(c3);
							}

							TransferObject->pHubList.Add(HubObject);
						}
						else if ( xml->name(c2) == XML_FILE )
						{
							DCTransferFileObject * TransferFileObject = new DCTransferFileObject();

							for(c3=c2->xmlChildrenNode;c3!=0;c3=c3->next)
							{
								if ( xml->name(c3) == XML_REMOTEFILE )
									TransferFileObject->m_sRemoteFile = xml->content(c3);
								else if ( xml->name(c3) == XML_LOCALFILENAME )
									TransferFileObject->m_sLocalFileName = xml->content(c3);
								else if ( xml->name(c3) == XML_SIZE )
									TransferFileObject->m_nSize = xml->content(c3).asULL();
								else if ( xml->name(c3) == XML_PRIORITY )
									TransferFileObject->m_nPriority = xml->content(c3).asINT();
								else if ( xml->name(c3) == XML_LOCALPATH )
									TransferFileObject->m_sLocalPath = xml->content(c3);
								else if ( xml->name(c3) == XML_LOCALFILE )
									TransferFileObject->m_sLocalFile = xml->content(c3);
								else if ( xml->name(c3) == XML_TEMPHASH )
									TransferFileObject->m_stHash = xml->content(c3);
								else if ( xml->name(c3) == XML_MD4HASH )
									TransferFileObject->m_sMD4Hash = xml->content(c3);
								else if ( xml->name(c3) == XML_MD5HASH )
									TransferFileObject->m_sMD5Hash = xml->content(c3);
								else if ( xml->name(c3) == XML_MD4HASHLIST )
								{
									for(c4=c3->xmlChildrenNode;c4!=0;c4=c4->next)
									{
										if ( xml->name(c4) == XML_MD4HASH )
											TransferFileObject->m_pMD4ChunkHashList.Add(new CString(xml->content(c4)));
									}
								}
								else if ( xml->name(c3) == XML_MEDIUM )
								{
									if ( xml->content(c3) == XML_MEDIUM_BUFFER )
										TransferFileObject->m_eMedium = eltBUFFER;
									else
										TransferFileObject->m_eMedium = eltFILE;
								}
								else if ( xml->name(c3) == XML_MULTI )
									TransferFileObject->m_bMulti = xml->getBoolChild(c3);
							}

							TransferObject->pTransferFileList.Add( TransferFileObject->m_sRemoteFile, TransferFileObject );
						}
					}

					if ( TransferObject->pTransferFileList.Count() == 0 )
					{
						delete TransferObject;
					}
					else
					{
						if ( queue->Get( TransferObject->sNick, (CObject*&)sl1 ) == 0 )
						{
							if ( sl1->Get( TransferObject->sHubName, (CObject*&)sl2 ) == 0 )
							{
								printf("load queue: error double entrys !!!!\n");
							}
							else
							{
								sl1->Add( TransferObject->sHubName, TransferObject );
							}
						}
						else
						{
							sl1 = new CStringList();
							sl1->Add( TransferObject->sHubName, TransferObject );
							queue->Add( TransferObject->sNick, sl1 );
						}
					}
				}
				else if ( xml->name(c1) == XML_FILECHUNK )
				{
					DCFileChunkObject * FileChunkObject = new DCFileChunkObject();

					for(c2=c1->xmlChildrenNode;c2!=0;c2=c2->next)
					{
						if ( xml->name(c2) == XML_LOCALFILE )
							FileChunkObject->sLocalFile = xml->content(c2);
						else if ( xml->name(c2) == XML_TEMPHASH )
							FileChunkObject->stHash = xml->content(c2);
						else if ( xml->name(c2) == XML_MD4HASH )
							FileChunkObject->sMD4Hash = xml->content(c2);
						else if ( xml->name(c2) == XML_SIZE )
							FileChunkObject->lSize = xml->content(c2).asULL();
						else if ( xml->name(c2) == XML_SIZEDONE )
							FileChunkObject->lSizeDone = xml->content(c2).asULL();
						else if ( xml->name(c2) == XML_REFCOUNT )
							FileChunkObject->iReferenceCount = xml->content(c2).asINT();
						else if ( xml->name(c2) == XML_MULTI )
							FileChunkObject->bMulti = xml->getBoolChild(c2);
						else if ( xml->name(c2) == XML_CHUNK )
						{
							DCChunkObject * ChunkObject = new DCChunkObject();

							for(c3=c2->xmlChildrenNode;c3!=0;c3=c3->next)
							{
								if ( xml->name(c3) == XML_START )
									ChunkObject->lStart = xml->content(c3).asULL();
								else if ( xml->name(c3) == XML_END )
									ChunkObject->lEnd = xml->content(c3).asULL();
							}

							FileChunkObject->pChunks.Add(ChunkObject);
						}
					}

					chunks->Add( FileChunkObject->sLocalFile, FileChunkObject );
				}
			}
		}
	}

	delete xml;

	return 0;
}

/** */
int CConfig::SaveDCTra( CStringList * queue, CStringList * chunks )
{
	int err;
	CString s,*st;
	xmlDocPtr doc;
	xmlNodePtr node,node1,node2;
	DCTransferQueueObject * TransferObject;
	DCFileChunkObject * FileChunkObject;
	DCChunkObject * ChunkObject;
	DCHubObject * HubObject;

	CStringList * sl1;

	CXml * xml;

	err = 0;

	xml = new CXml();
	doc = xmlNewDoc((const xmlChar*)"1.0");

	doc->children = xmlNewDocNode(doc,0,(const xmlChar*)XML_DCTRA_CONFIG,0);

	// nick,stringlist
	sl1 = 0;
	while(queue->Next((CObject*&)sl1))
	{
		// hubname,transferobject
		TransferObject = 0;
		while(sl1->Next((CObject*&)TransferObject))
		{
			if ( TransferObject->pTransferFileList.Count() == 0 )
			{
				continue;
			}

			node = xmlNewChild( doc->children, 0, (const xmlChar*)XML_TRANSFER, 0 );

			// store nick,hubhost and hubname
			xmlNewChild( node, 0, (const xmlChar*)XML_NICK,      (const xmlChar*) xml->ToUTF8(TransferObject->sNick).Data());
			xmlNewChild( node, 0, (const xmlChar*)XML_HUBNAME,   (const xmlChar*) xml->ToUTF8(TransferObject->sHubName).Data());
			xmlNewChild( node, 0, (const xmlChar*)XML_HUBHOST,   (const xmlChar*) xml->ToUTF8(TransferObject->sHubHost).Data());

			HubObject = 0;

			while( (HubObject=TransferObject->pHubList.Next(HubObject)) != 0 )
			{
				node1 = xmlNewChild( node, 0, (const xmlChar*)XML_HUB, 0 );

				xmlNewChild( node1, 0, (const xmlChar*)XML_HUBNAME, (const xmlChar*) xml->ToUTF8(HubObject->m_sHubName).Data());
				xmlNewChild( node1, 0, (const xmlChar*)XML_HUBHOST, (const xmlChar*) xml->ToUTF8(HubObject->m_sHubHost).Data());
				xml->xmlNewBoolChild( node1, 0, (const xmlChar*)XML_ACTIVE, HubObject->m_bActive );
			}

			// save files
			DCTransferFileObject * TransferFileObject = 0;
			while(TransferObject->pTransferFileList.Next((CObject*&)TransferFileObject))
			{
				node1 = xmlNewChild( node, 0, (const xmlChar*)XML_FILE, 0 );

				xmlNewChild( node1, 0, (const xmlChar*)XML_REMOTEFILE, (const xmlChar*) xml->ToUTF8(TransferFileObject->m_sRemoteFile).Data());
				xmlNewChild( node1, 0, (const xmlChar*)XML_LOCALFILENAME, (const xmlChar*) xml->ToUTF8(TransferFileObject->m_sLocalFileName).Data());
				xmlNewChild( node1, 0, (const xmlChar*)XML_SIZE,(const xmlChar*) CString().setNum(TransferFileObject->m_nSize).Data());
				xmlNewChild( node1, 0, (const xmlChar*)XML_PRIORITY,(const xmlChar*) CString().setNum(TransferFileObject->m_nPriority).Data());
				xmlNewChild( node1, 0, (const xmlChar*)XML_LOCALFILE, (const xmlChar*) xml->ToUTF8(TransferFileObject->m_sLocalFile).Data());
				xmlNewChild( node1, 0, (const xmlChar*)XML_LOCALPATH, (const xmlChar*) xml->ToUTF8(TransferFileObject->m_sLocalPath).Data());

				xml->xmlNewStringChild( node1, 0, (const xmlChar*)XML_TEMPHASH, TransferFileObject->m_stHash, FALSE );
				xml->xmlNewStringChild( node1, 0, (const xmlChar*)XML_MD4HASH,  TransferFileObject->m_sMD4Hash, FALSE );
				xml->xmlNewStringChild( node1, 0, (const xmlChar*)XML_MD5HASH,  TransferFileObject->m_sMD5Hash, FALSE );

				if ( TransferFileObject->m_pMD4ChunkHashList.Count() > 0 )
				{
					node2 = xmlNewChild( node, 0, (const xmlChar*)XML_MD4HASHLIST, 0 );
					st = 0;

					while ( (st = TransferFileObject->m_pMD4ChunkHashList.Next(st)) != 0 )
					{
						xmlNewChild( node2, 0, (const xmlChar*)XML_MD4HASH, (const xmlChar*) xml->ToUTF8(*st).Data());
					}
				}

				if(TransferFileObject->m_eMedium==eltBUFFER)
					s = XML_MEDIUM_BUFFER;
				else
					s = XML_MEDIUM_FILE;			
				xmlNewChild( node1, 0, (const xmlChar*)XML_MEDIUM, (const xmlChar*) xml->ToUTF8(s).Data());

				xml->xmlNewBoolChild( node1, 0, (const xmlChar*)XML_MULTI, TransferFileObject->m_bMulti );
			}
		}
	}

	FileChunkObject = 0;
	while( chunks->Next((CObject*&)FileChunkObject) )
	{
		node = xmlNewChild( doc->children, 0, (const xmlChar*)XML_FILECHUNK, 0 );

		xmlNewChild( node, 0, (const xmlChar*)XML_LOCALFILE, (const xmlChar*) xml->ToUTF8(FileChunkObject->sLocalFile).Data());
		xmlNewChild( node, 0, (const xmlChar*)XML_TEMPHASH,(const xmlChar*) xml->ToUTF8(FileChunkObject->stHash).Data());
		xmlNewChild( node, 0, (const xmlChar*)XML_MD4HASH,(const xmlChar*) xml->ToUTF8(FileChunkObject->sMD4Hash).Data());
		xmlNewChild( node, 0, (const xmlChar*)XML_SIZE,(const xmlChar*) CString().setNum(FileChunkObject->lSize).Data());
		xmlNewChild( node, 0, (const xmlChar*)XML_SIZEDONE,(const xmlChar*) CString().setNum(FileChunkObject->lSizeDone).Data());
		xmlNewChild( node, 0, (const xmlChar*)XML_REFCOUNT,(const xmlChar*) CString().setNum(FileChunkObject->iReferenceCount).Data());
		xml->xmlNewBoolChild( node, 0, (const xmlChar*)XML_MULTI, FileChunkObject->bMulti );

		ChunkObject = 0;

		while( (ChunkObject=FileChunkObject->pChunks.Next(ChunkObject)) != 0 )
		{
			node1 = xmlNewChild( node, 0, (const xmlChar*)XML_CHUNK, 0 );
			xmlNewChild( node1, 0, (const xmlChar*)XML_START,(const xmlChar*) CString().setNum(ChunkObject->lStart).Data());
			xmlNewChild( node1, 0, (const xmlChar*)XML_END,(const xmlChar*) CString().setNum(ChunkObject->lEnd).Data());
		}
	}

	s = sConfigPath + DCTRA_CONFIG;

	if ( xmlSaveFormatFile(s.Data(),doc,1) == -1 )
	{
		err = -1;
	}

	xmlFreeDoc(doc);
	delete xml;

	return err;
}

/** */
int CConfig::LoadDCShare( CThreadStringList * share )
{
	CXml * xml;
	xmlNodePtr node,c1,c2; //,c3;
	CString s;
	CFileBaseObject * FileBaseObject;

	s = sConfigPath + DCSHARE_CONFIG;

	xml = new CXml();

	if ( xml->ParseFile(s) == FALSE )
	{
		delete xml;
		return -1;
	}

	for(node=xml->doc()->children;node!=0;node=node->next)
	{
		if ( xml->name(node) == XML_DCSHARE_CONFIG )
		{
			for(c1=node->xmlChildrenNode;c1!=0;c1=c1->next)
			{
				if ( xml->name(c1) == XML_FILEENTRY )
				{
					FileBaseObject = new CFileBaseObject();

					for(c2=c1->xmlChildrenNode;c2!=0;c2=c2->next)
					{
						if ( xml->name(c2) == XML_FILE )
							FileBaseObject->sFile = xml->content(c2);
						else if ( xml->name(c2) == XML_PATH )
							FileBaseObject->sPath = xml->content(c2);
						else if ( xml->name(c2) == XML_TYPE )
							FileBaseObject->eFileType = (enum eFileTypes)xml->content(c2).asINT();
						else if ( xml->name(c2) == XML_SIZE )
							FileBaseObject->lSize = xml->content(c2).asULL();
//						else if ( xml->name(c2) == XML_MD4HASH )
//							FileBaseObject->sMD4Hash = xml->content(c2);
//						else if ( xml->name(c2) == XML_MD5HASH )
//							FileBaseObject->sMD5Hash = xml->content(c2);
//						else if ( xml->name(c2) == XML_MD4HASHLIST )
//						{
//							for(c3=c2->xmlChildrenNode;c3!=0;c3=c3->next)
//							{
//								if ( xml->name(c3) == XML_MD4HASH )
//									FileBaseObject->pMD4ChunkHashList.Add(new CString(xml->content(c3)));
//							}
//						}
//						if ( xml->name(c2) == XML_ATIME )
//							FileBaseObject->st_a_time = xml->content(c2).asULL();
//						else if ( xml->name(c2) == XML_CTIME )
//							FileBaseObject->st_c_time = xml->content(c2).asLONG();
//						else if ( xml->name(c2) == XML_MTIME )
//							FileBaseObject->st_m_time = xml->content(c2).asLONG();
					}

					FileBaseObject->ID = share->Count()+1;
					share->Add( CString().setNum(FileBaseObject->ID), FileBaseObject );
				}
			}
		}
	}

	delete xml;

	return 0;
}

/** */
int CConfig::SaveDCShare( CThreadStringList * share )
{
	int err;
	CString s; //,*st;
	xmlDocPtr doc;
	xmlNodePtr node; //,node1;
	CObject * Object;
	CFileBaseObject * FileBaseObject;
	CXml * xml;

	err = 0;

	xml = new CXml();
	doc = xmlNewDoc((const xmlChar*)"1.0");

	doc->children = xmlNewDocNode(doc,0,(const xmlChar*)XML_DCSHARE_CONFIG,0);

	Object = 0;
	while(share->Next((CObject*&)Object))
	{
		FileBaseObject = (CFileBaseObject*)Object;

		node = xmlNewChild( doc->children, 0, (const xmlChar*)XML_FILEENTRY, 0 );

		// store nick,hubhost and hubname
		xmlNewChild( node, 0, (const xmlChar*)XML_FILE, (const xmlChar*) xml->ToUTF8(FileBaseObject->sFile).Data());
		xmlNewChild( node, 0, (const xmlChar*)XML_PATH, (const xmlChar*) xml->ToUTF8(FileBaseObject->sPath).Data());
		xmlNewChild( node, 0, (const xmlChar*)XML_SIZE, (const xmlChar*) CString().setNum(FileBaseObject->lSize).Data());
		xmlNewChild( node, 0, (const xmlChar*)XML_TYPE, (const xmlChar*) CString().setNum(FileBaseObject->eFileType).Data());
//		xmlNewChild( node, 0, (const xmlChar*)XML_CTIME, (const xmlChar*) CString().setNum(FileBaseObject->st_c_time).Data());
//		xmlNewChild( node, 0, (const xmlChar*)XML_MTIME, (const xmlChar*) CString().setNum(FileBaseObject->st_m_time).Data());
//		xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_MD4HASH, FileBaseObject->sMD4Hash, FALSE );
//		xml->xmlNewStringChild( node, 0, (const xmlChar*)XML_MD5HASH, FileBaseObject->sMD5Hash, FALSE );
//
//		if ( FileBaseObject->pMD4ChunkHashList.Count() > 0 )
//		{
//			node1 = xmlNewChild( node, 0, (const xmlChar*)XML_MD4HASHLIST, 0 );
//
//			st = 0;
//			while ( (st = FileBaseObject->pMD4ChunkHashList.Next(st)) != 0 )
//			{
//				xmlNewChild( node1, 0, (const xmlChar*)XML_MD4HASH, (const xmlChar*) xml->ToUTF8(*st).Data());
//			}
//		}
	}

	s = sConfigPath + DCSHARE_CONFIG;

	if ( xmlSaveFormatFile(s.Data(),doc,1) == -1 )
	{
		err = -1;
	}

	xmlFreeDoc(doc);
	delete xml;

	return err;
}

/** */
CString CConfig::ParseVersion( CString s )
{
	CString release;
	xmlDocPtr doc;
	xmlNodePtr node,n1,n2;
	xmlChar * c;

	release = "";

	doc = xmlParseMemory(s.Data(),s.Length());

	if ( doc == 0 )
	{
		return "";
	}
	else
	{
		for(node=doc->children;node!=0;node=node->next)
		{
			if ( !xmlStrcmp( node->name, (const xmlChar*)XML_DC ) )
			{
				for(n1=node->xmlChildrenNode;n1!=0;n1=n1->next)
				{
					if ( !xmlStrcmp( n1->name, (const xmlChar*)XML_VERSION ) )
					{
						for(n2=n1->xmlChildrenNode;n2!=0;n2=n2->next)
						{
							if ( !xmlStrcmp( n2->name, (const xmlChar*)XML_RELEASE ) )
							{
								if ( (c = xmlNodeGetContent(n2)) != 0 )
								{
									release = (const char*)c;
									xmlFree(c);
								}
							}
						}
					}
				}
			}
		}

		xmlFreeDoc(doc);
	}

	return release;
}

/** */
void CConfig::ParseDCHubConfig( xmlNodePtr node )
{
	CXml * xml;
	xmlNodePtr n1,n2,n3;

	xml = new CXml();

	for(n1=node;n1!=0;n1=n1->next)
	{
		/* parse server entrys */
		if ( xml->name(n1) == XML_SERVER )
		{
			for(n2=n1->xmlChildrenNode;n2!=0;n2=n2->next)
			{
				// public hub list
				if ( xml->name(n2) == XML_PUBLIC )
				{
					DCConfigHubItem * hubitem = new DCConfigHubItem();

					for(n3=n2->xmlChildrenNode;n3!=0;n3=n3->next)
					{
						if ( xml->name(n3) == XML_NAME )
							hubitem->sName = xml->content(n3);
						else if ( xml->name(n3) == XML_HOST )
							hubitem->sHost = xml->content(n3);
						else if ( xml->name(n3) == XML_DESCRIPTION )
							hubitem->sDescription = xml->content(n3);
						else if ( xml->name(n3) == XML_USERCOUNT )
							hubitem->sUserCount = xml->content(n3);
					}

					pPublicHubList->Add(hubitem->sName.ToUpper(),hubitem);
					pPublicHubList_HostIndex->Add(hubitem->sHost.ToUpper(),new CString(hubitem->sName));
				}
			}
		}
	}

	delete xml;
}

/** */
void CConfig::ParseDCBookHubConfig( xmlNodePtr node )
{
	CXml * xml;
	xmlNodePtr n1,n2,n3;

	xml = new CXml();

	for(n1=node;n1!=0;n1=n1->next)
	{
		/* parse server entrys */
		if ( xml->name(n1) == XML_SERVER )
		{
			for(n2=n1->xmlChildrenNode;n2!=0;n2=n2->next)
			{
				// bookmark hub list
				if ( xml->name(n2) == XML_PUBLIC )
				{
					DCConfigHubItem * hubitem = new DCConfigHubItem();

					for(n3=n2->xmlChildrenNode;n3!=0;n3=n3->next)
					{
						if ( xml->name(n3) == XML_NAME )
							hubitem->sName = xml->content(n3);
						else if ( xml->name(n3) == XML_HOST )
							hubitem->sHost = xml->content(n3);
						else if ( xml->name(n3) == XML_DESCRIPTION )
							hubitem->sDescription = xml->content(n3);
						else if ( xml->name(n3) == XML_PROFILE_NAME )
							hubitem->sProfile = xml->content(n3);
					}

					pBookmarkHubList->Add(hubitem->sName,hubitem);
				}
			}
		}
	}

	delete xml;
}

/** */
void CConfig::ParseDCLibConfig( xmlNodePtr node )
{
	CXml * xml;
	xmlNodePtr n1,n2,n3;

	xml = new CXml();

	for(n1=node;n1!=0;n1=n1->next)
	{
		/* parse identify entrys */
		if ( xml->name(n1) == XML_IDENTIFY )
		{
			for(n2=n1->xmlChildrenNode;n2!=0;n2=n2->next)
			{
				if ( xml->name(n2) == XML_NICK )
					sNick = xml->content(n2);
				else if ( xml->name(n2) == XML_SEARCHNICK )
					sSearchNick = xml->content(n2);
				else if ( xml->name(n2) == XML_AWAYMESSAGE )
					sAwayMessage = xml->content(n2);
				else if ( xml->name(n2) == XML_EMAIL )
					sEMail = xml->content(n2);
				else if ( xml->name(n2) == XML_ANTISPAM )
					bAntiSpam = xml->getBoolChild(n2);
				else if ( xml->name(n2) == XML_DESCRIPTION )
					sDescription = xml->content(n2);
				else if ( xml->name(n2) == XML_DESCRIPTION_TAG )
					bDescriptionTag = xml->getBoolChild(n2);
				else if ( xml->name(n2) == XML_SPEED )
					sSpeed = xml->content(n2);
			}
		}
		/* parse logfile entry */
		else if ( xml->name(n1) == XML_LOGFILE )
		{
			for(n2=n1->xmlChildrenNode;n2!=0;n2=n2->next)
			{
				if ( xml->name(n2) == XML_LOGFILENAME )
					sLogFile = xml->content(n2);
				else if ( xml->name(n2) == XML_LOGFILEON )
					bLogFile = xml->getBoolChild(n2);
			}
		}
		else if ( xml->name(n1) == XML_SECURITY )
		{
			for(n2=n1->xmlChildrenNode;n2!=0;n2=n2->next)
			{
				if ( xml->name(n2) == XML_FLOODOPKICKMESSAGE )
					sFloodOpKickMessage = xml->content(n2);
			}
		
		}
		/* parse transfer entrys */
		else if ( xml->name(n1) == XML_TRANSFER )
		{
			for(n2=n1->xmlChildrenNode;n2!=0;n2=n2->next)
			{
				if ( xml->name(n2) == XML_DOWNLOADFOLDER )
					sDownloadFolder = xml->content(n2);
				else if ( xml->name(n2) == XML_DOWNLOADFINISHEDFOLDER )
					sDownloadFinishedFolder = xml->content(n2);
				else if ( xml->name(n2) == XML_SHAREDFOLDER )
				{
					if ( xml->content(n2) != "" )
						SharedFolders.Add( new CString(xml->content(n2)) );
				}
				else if ( xml->name(n2) == XML_AUTORECREATESHARELIST )
					bAutoRecreateShareList = xml->getBoolChild(n2);
				else if ( xml->name(n2) == XML_MAXUPLOAD )
					iMaxUpload = xml->content(n2).asINT();
				else if ( xml->name(n2) == XML_USER_UPLOAD_SLOTS )
					iUserUploadSlots = xml->content(n2).asINT();
				else if ( xml->name(n2) == XML_MAXUPLOADRATE )
					lMaxUploadRate = xml->content(n2).asULL();
				else if ( xml->name(n2) == XML_MAXDOWNLOADRATE )
					lMaxDownloadRate = xml->content(n2).asULL();
				else if ( xml->name(n2) == XML_DOWNLOADQUEUETIME )
					iDownloadQueueTime = xml->content(n2).asINT();
				else if ( xml->name(n2) == XML_DYNAMICUPLOADRATE )
					bDynamicUploadRate = xml->getBoolChild(n2);
				else if ( xml->name(n2) == XML_TRANSFER_CERT )
					m_sTransferCert = xml->content(n2);
				else if ( xml->name(n2) == XML_TRANSFER_KEY )
					m_sTransferKey = xml->content(n2);
				else if ( xml->name(n2) == XML_HUBOFFLINE_TRANSFERCLOSE )
					eHubOfflineTransferClose = (eCloseType)xml->content(n2).asINT();
			}
		}
		/* parse connection entrys */
		else if ( xml->name(n1) == XML_CONNECTION )
		{
			for(n2=n1->xmlChildrenNode;n2!=0;n2=n2->next)
			{
				if ( xml->name(n2) == XML_MODE )
				{
					if ( xml->content(n2) == XML_MODE_PASSIVE )
						eMode = ecmPassive;
					else
						eMode = ecmActive;
				}
				else if ( xml->name(n2) == XML_TCPLISTENPORT )
					iTCPListenPort = xml->content(n2).asINT();
				else if ( xml->name(n2) == XML_UDPLISTENPORT )
					iUDPListenPort = xml->content(n2).asINT();
				else if ( xml->name(n2) == XML_IP )
					sHost = xml->content(n2);
				else if ( xml->name(n2) == XML_INTERFACE )
					sInterface = xml->content(n2);
				else if ( xml->name(n2) == XML_CHANGEIP )
					iFakeHost = xml->content(n2).asINT();
				else if ( xml->name(n2) == XML_SENDMESSAGEONACTIVEMODEREQUEST )
					bSendMessageOnActiveModeRequest = xml->getBoolChild(n2);
				else if ( xml->name(n2) == XML_CHECKPRIVATEADDRESSSPACE )
					bCheckPrivateAddressSpace = xml->getBoolChild(n2);
			}
		}
		/* other entrys */
		else if ( xml->name(n1) == XML_OTHER )
		{
			for(n2=n1->xmlChildrenNode;n2!=0;n2=n2->next)
			{
				if ( xml->name(n2) == XML_HUBLISTSTORELOCAL )
					bHubListStoreLocal = xml->getBoolChild(n2);
				else if ( xml->name(n2) == XML_RECONNECTCOUNT )
					iReconnectCount = xml->content(n2).asINT();
				else if ( xml->name(n2) == XML_RECONNECTTIMEOUT )
					iReconnectTimeout = xml->content(n2).asINT();
				else if ( xml->name(n2) == XML_TRANSFERRESPONSETIMEOUT )
					iTransferResponseTimeout = xml->content(n2).asINT();
				else if ( xml->name(n2) == XML_TRANSFERRESENDTIMEOUT )
					iTransferResendTimeout = xml->content(n2).asINT();
				else if ( xml->name(n2) == XML_FORCEMOVEENABLED )
					bForceMoveEnabled = xml->getBoolChild(n2);
				else if ( xml->name(n2) == XML_DATADIR )
					sDatadir = xml->content(n2);
				else if ( xml->name(n2) == XML_CHATSENDOFFLINEMESSAGES )
					bChatSendOfflineMessages = xml->getBoolChild(n2);
				else if ( xml->name(n2) == XML_CHATRECVOFFLINEMESSAGES )
					bChatRecvOfflineMessages = xml->getBoolChild(n2);
			}
		}
		/* parse server entrys */
		else if ( xml->name(n1) == XML_HUBLISTURL )
		{
			for(n2=n1->xmlChildrenNode;n2!=0;n2=n2->next)
			{
				if ( xml->name(n2) == XML_URL )
				{
					DCConfigHubListUrl * hublisturl = new DCConfigHubListUrl();

					for(n3=n2->xmlChildrenNode;n3!=0;n3=n3->next)
					{
						if ( xml->name(n3) == XML_NAME )
							hublisturl->sUrl = xml->content(n3);
						else if ( xml->name(n3) == XML_ENABLED )
							hublisturl->bEnabled = xml->getBoolChild(n3);
					}

					pHubListUrlList.Add(hublisturl);
				}
			}
		}
		/* parse search history */
		else if ( xml->name(n1) == XML_SEARCH_HISTORY )
		{
			for(n2=n1->xmlChildrenNode;n2!=0;n2=n2->next)
			{
				if ( xml->name(n2) == XML_NAME )
					pSearchHistory->Add( new CString(xml->content(n2)) );
			}
		}
	}

	delete xml;
}

/** */
CString CConfig::GetEMail( bool raw )
{
	Thread.Lock();

	CString s;

	s = sEMail;

	if ( (raw == FALSE) && (bAntiSpam==TRUE) )
	{
		s = s.Replace( '@', " at " );
		s = s.Replace( '.', " dot " );
	}

	Thread.UnLock();

	return s;
}

/** */
CString CConfig::GetDescription( bool raw )
{
	Thread.Lock();

	CString s;

	s = sDescription;
	
	// Fake share bug fix :)
	s = s.Replace( '$', "_" );
	s = s.Replace( '|', "_" );

	if ( s.Find("<DCGUI ") != -1 )
	{
		s = s.Replace( '<', "_" );
		s = s.Replace( '>', "_" );
	}

	if ( s.Find("<++ ") != -1 )
	{
		s = s.Replace( '<', "_" );
		s = s.Replace( '>', "_" );
	}

	if ( (bDescriptionTag == TRUE) && (raw == FALSE) )
	{
		s += "<DCGUI V:";
		s += VERSION;
		s += ",M:";

		switch (eMode)
		{
			case ecmActive:
				s += "A";
				break;
			case ecmPassive:
				s += "P";
				break;
			default:
				s += "U";
				break;
		}

		s += ",H:";

		if ( CServerManager::Instance() )
		{		
			s += CString().setNum(CServerManager::Instance()->GetConnectedHubCount());
		}
		else
		{
			s += "0";
		}

		s += ",S:";

		if ( (iMaxUpload == 0) || (!CDownloadManager::Instance()) )
		{
			s += "*";
		}
		else
		{
			/* total # of slots open
			   more Hub Script DC++ Tag Checking friendly */
			s += CString().setNum(iMaxUpload);
		}

		s += ",L:";

		if ( lMaxUploadRate == 0 )
		{
			s += "*";
		}
		else
		{
			s += CString().setNum(lMaxUploadRate/1024);
		}

		s += ">";
	}

	Thread.UnLock();

	return s;
}

/** */
void CConfig::SetSharedFolders( CList<CString> * list )
{
	CString * s = 0;

	if (!list)
	{
		return;
	}

	SharedFolders.Clear();

	while ( (s=list->Next(s)) != 0 )
	{
		SharedFolders.Add( new CString(*s) );
	}

	return;
}

/** */
long CConfig::GetSharedFolders( CList<CString> * list )
{
	CString * s = 0;

	if (!list)
	{
		return 0;
	}

	list->Clear();

	while ( (s=SharedFolders.Next(s)) != 0 )
	{
		list->Add( new CString(*s) );
	}

	return list->Count();
}

/** */
int CConfig::GetShareBuffer( eShareBufferType type, CByteArray * sharebuffer )
{
	Thread.Lock();

	int err = 0;

	if( !sharebuffer )
	{
		err = -1;
	}
	else
	{
		switch(type)
		{
			case esbtHE3:
				if ( !m_pHE3ShareBuffer )
					err = -1;
				else
					sharebuffer->Append(m_pHE3ShareBuffer->Data(),m_pHE3ShareBuffer->Size());
				break;
			case esbtBZ:
				if ( !m_pBZShareBuffer )
					err = -1;
				else
					sharebuffer->Append(m_pBZShareBuffer->Data(),m_pBZShareBuffer->Size());
				break;
			default:
				err = -1;
				break;
		}
	}

	Thread.UnLock();

	return err;
}

/** */
long CConfig::GetShareBufferSize( eShareBufferType type )
{
	long i = 0;

	Thread.Lock();

	switch(type)
	{
		case esbtHE3:
			if ( m_pHE3ShareBuffer )
				i = m_pHE3ShareBuffer->Size();
			break;
		case esbtBZ:
			if ( m_pBZShareBuffer )
				i = m_pBZShareBuffer->Size();
			break;
		default:
			break;
	}

	Thread.UnLock();

	return i;
}

/** */
bool CConfig::RemoveBookmarkHub( CString name, CString /*host*/, CString /*description*/ )
{
	Thread.Lock();

	bool err = FALSE;
	DCConfigHubItem * hubitem;

	hubitem = 0;

	if ( pBookmarkHubList->Get(name,(CObject*&)hubitem) == 0 )
	{
		pBookmarkHubList->Del(hubitem->sName);
		err = TRUE;
	}

	Thread.UnLock();

	return err;
}

/** */
bool CConfig::AddBookmarkHub( CString name, CString host, CString description )
{
	Thread.Lock();

	bool err = TRUE;
	DCConfigHubItem * hubitem;

	hubitem = 0;

	if ( pBookmarkHubList->Get(name,(CObject*&)hubitem) == 0 )
	{
		// update
		hubitem->sHost        = host;
		hubitem->sDescription = description;
		err = FALSE;
	}

	if ( err == TRUE )
	{
		hubitem = new DCConfigHubItem();

		hubitem->sName = name;
		hubitem->sHost = host;
		hubitem->sDescription = description;
		pBookmarkHubList->Add(name,hubitem);
	}

	Thread.UnLock();

	return err;
}

/** */
bool CConfig::UpdateBookmarkHub( CString name, CString host, CString description )
{
	Thread.Lock();

	bool err = FALSE;
	DCConfigHubItem * hubitem;

	hubitem = 0;

	if ( pBookmarkHubList->Get(name,(CObject*&)hubitem) == 0 )
	{
		// update
		hubitem->sHost        = host;
		hubitem->sDescription = description;
		err = TRUE;
	}

	Thread.UnLock();

	return err;
}

/** */
void CConfig::ClearPublicHubList()
{
	Thread.Lock();
	pPublicHubList->Clear();
	pPublicHubList_HostIndex->Clear();
	Thread.UnLock();
}

/** */
bool CConfig::RemovePublicHub( CString name, CString /*host*/, CString /*description*/ )
{
	Thread.Lock();

	bool err = FALSE;
	DCConfigHubItem * hubitem;

	hubitem = 0;

	if ( pPublicHubList->Get(name,(CObject*&)hubitem) == 0 )
	{
		pPublicHubList_HostIndex->Del(hubitem->sHost);
		pPublicHubList->Del(hubitem->sName);
		err = TRUE;
	}

	Thread.UnLock();

	return err;
}

/** */
bool CConfig::AddPublicHub( const CString name, const CString host, const CString description, const CString usercount )
{
	if ( (name == "") || (host == "") )
	{
		return FALSE;
	}

	Thread.Lock();

	bool badd = TRUE;
	DCConfigHubItem * hubitem;
	CString *ps;
	CString sname,shost;

	sname = name;
	sname = sname.ToUpper();
	shost = host;
	shost = shost.ToUpper();

	hubitem = 0;

	if ( pPublicHubList->Get(sname,(CObject*&)hubitem) == 0 )
	{
		// hub found by name

		// update host index
		pPublicHubList_HostIndex->Del(hubitem->sHost.ToUpper());
		pPublicHubList_HostIndex->Add(shost,new CString(name));

		// if another hub with the new ip present ?
		if ( pPublicHubList_HostIndex->Get(shost,(CObject*&)ps) == 0 )
		{
			if ( *ps != name )
			{
				// remove this entry
				pPublicHubList->Del(ps->ToUpper());
				pPublicHubList_HostIndex->Del(shost);
			}
		}

		// update host
		hubitem->sHost        = name;
		hubitem->sHost        = host;
		hubitem->sDescription = description;
		hubitem->sUserCount   = usercount;
		badd = FALSE;
	}
	else
	{
		// hub not found, check if hub exists in the host index
		if ( pPublicHubList_HostIndex->Get(shost,(CObject*&)ps) == 0 )
		{
			// hub by host found
			if ( pPublicHubList->Get(ps->ToUpper(),(CObject*&)hubitem) == 0 )
			{
				pPublicHubList->Del(ps->ToUpper());
				pPublicHubList_HostIndex->Del(shost);
			}
			else
			{
				printf("warning public hub list inconsistent !\n");
			}
		}
	}

	if ( badd == TRUE )
	{
		hubitem = new DCConfigHubItem();

		hubitem->sName        = name;
		hubitem->sHost        = host;
		hubitem->sDescription = description;
		hubitem->sUserCount   = usercount;
		pPublicHubList->Add(sname,hubitem);
		pPublicHubList_HostIndex->Add(shost,new CString(name));
	}

	Thread.UnLock();

	return badd;
}

/** */
CString CConfig::GetTCPHostString()
{
	Thread.Lock();

	CSocket Socket;
	CString s,h;

	if ( iFakeHost == 1 )
	{
		s = sHost;
	}
	else
	{
		s = Socket.GetInterfaceIP( sInterface.Data() );
	}

	if ( s != "" )
	{
		h = CSocket::GetHostByName(s);

		if ( h != "" )
		{
			s = h + ":" + CString().setNum(iTCPListenPort).Data();
		}
		else
		{
			s = "";
		}
	}

	Thread.UnLock();

	return s.Data();
}

/** */
CString CConfig::GetUDPHostString()
{
	Thread.Lock();

	CSocket Socket;
	CString s,h;

	if ( iFakeHost == 1 )
	{
		s = sHost;
	}
	else
	{
		s = Socket.GetInterfaceIP( sInterface.Data() );
	}

	if ( s != "" )
	{
		h = CSocket::GetHostByName(s);

		if ( h != "" )
		{
			s = h + ":" + CString().setNum(iUDPListenPort).Data();
		}
		else
		{
			s = "";
		}
	}

	Thread.UnLock();

	return s.Data();
}

/** */
long CConfig::GetBookmarkHubList( CList<DCConfigHubItem> * list )
{
	DCConfigHubItem * item = 0, *newitem;

	if (!list)
	{
		return 0;
	}

	list->Clear();

	Thread.Lock();

	while ( pBookmarkHubList->Next((CObject*&)item) != 0 )
	{
		newitem = new DCConfigHubItem( item );
		list->Add(newitem);
	}

	Thread.UnLock();

	return list->Count();
}

/** */
long CConfig::GetPublicHubList( CList<DCConfigHubItem> * list )
{
	DCConfigHubItem * item = 0, *newitem;

	if (!list)
	{
		return 0;
	}

	list->Clear();

	Thread.Lock();

	while ( pPublicHubList->Next((CObject*&)item) != 0 )
	{
		newitem = new DCConfigHubItem( item );
		list->Add(newitem);
	}

	Thread.UnLock();

	return list->Count();
}

/** */
bool CConfig::GetBookmarkHub( CString name, DCConfigHubItem * hubitem )
{
	bool err = FALSE;
	DCConfigHubItem * hubitem1;

	if ( !hubitem )
	{
		return err;
	}

	hubitem1 = 0;

	Thread.Lock();

	if ( pBookmarkHubList->Get(name,(CObject*&)hubitem1) == 0 )
	{
		// update
		hubitem->sName        = hubitem1->sName;
		hubitem->sHost        = hubitem1->sHost;
		hubitem->sDescription = hubitem1->sDescription;
		hubitem->sUserCount   = hubitem1->sUserCount;
		hubitem->sProfile     = hubitem1->sProfile;
		err = TRUE;
	}

	Thread.UnLock();

	return err;
}

/** */
bool CConfig::SetBookmarkHubProfile( CString name, CString profile )
{
	bool err = FALSE;
	DCConfigHubItem * hubitem;

	Thread.Lock();

	if ( pBookmarkHubList->Get(name,(CObject*&)hubitem) == 0 )
	{
		// update
		hubitem->sProfile = profile;

		err = TRUE;
	}

	Thread.UnLock();

	return err;
}

/** */
bool CConfig::GetBookmarkHubProfile( CString name, DCConfigHubProfile * p )
{
	bool err = FALSE;
	DCConfigHubItem * hubitem;
	DCConfigHubProfile * ConfigHubProfile;

	Thread.Lock();

	if ( pBookmarkHubList->Get(name,(CObject*&)hubitem) == 0 )
	{
		if ( hubitem->sProfile != "" )
		{
			if ( pHubProfileList->Get( hubitem->sProfile, (CObject*&)ConfigHubProfile ) == 0 )
			{
				p->sName        = ConfigHubProfile->sName;
				p->sPassword    = ConfigHubProfile->sPassword;
				p->bAutoConnect = ConfigHubProfile->bAutoConnect;
				err = TRUE;
			}
		}
	}

	Thread.UnLock();

	return err;
}

/** */
bool CConfig::GetPublicHub( CString name, DCConfigHubItem * hubitem )
{
	bool err = FALSE;
	DCConfigHubItem * hubitem1;

	if ( !hubitem )
	{
		return err;
	}

	hubitem1 = 0;

	Thread.Lock();

	if ( pPublicHubList->Get(name,(CObject*&)hubitem1) == 0 )
	{
		// update
		hubitem->sName        = hubitem1->sName;
		hubitem->sHost        = hubitem1->sHost;
		hubitem->sDescription = hubitem1->sDescription;
		hubitem->sUserCount   = hubitem1->sUserCount;
		hubitem->sProfile     = hubitem1->sProfile;
		err = TRUE;
	}

	Thread.UnLock();

	return err;
}

/** */
long CConfig::GetHubListUrlList( CList<DCConfigHubListUrl> * list )
{
	DCConfigHubListUrl * item = 0, *newitem;

	if (!list)
	{
		return 0;
	}

	list->Clear();

	Thread.Lock();

	while ( (item=pHubListUrlList.Next(item)) != 0 )
	{
		newitem = new DCConfigHubListUrl();

		newitem->bEnabled = item->bEnabled;
		newitem->sUrl     = item->sUrl;

		list->Add(newitem);
	}

	Thread.UnLock();

	return list->Count();
}

/** */
void CConfig::SetHubListUrlList( CList<DCConfigHubListUrl> * list )
{
	DCConfigHubListUrl * item = 0, *newitem;

	pHubListUrlList.Clear();

	if (!list)
	{
		return;
	}

	Thread.Lock();

	while ( (item=list->Next(item)) != 0 )
	{
		newitem = new DCConfigHubListUrl();

		newitem->bEnabled = item->bEnabled;
		newitem->sUrl     = item->sUrl;

		pHubListUrlList.Add(newitem);
	}

	Thread.UnLock();

	return;
}

/** */
void CConfig::SetShareBuffer( CString sharebuffer, ulonglong size )
{
	CByteArray * ba;
	CByteArray iba;
	CHE3  * he3;
	CBZ * bz;

	Thread.Lock();

	if ( sharebuffer == "" )
	{
		iShareSize = 0;
	}
	else
	{
		iShareSize = size;
	}

	if ( m_pHE3ShareBuffer )
	{
		delete m_pHE3ShareBuffer;
		m_pHE3ShareBuffer = 0;
	}

	if ( m_pBZShareBuffer )
	{
		delete m_pBZShareBuffer;
		m_pBZShareBuffer = 0;
	}

	if ( sharebuffer != "" )
	{
		// he3 compression
		he3 = new CHE3();
		ba = he3->encode_he3_data(&sharebuffer);
		delete he3;

		if ( ba != 0 )
		{
			m_pHE3ShareBuffer = ba;
		}
		else
		{
			printf("[ERROR] he3 compression failed\n");
		}

		// bz compression
		m_pBZShareBuffer = new CByteArray();

		iba.Append(sharebuffer.Data(),sharebuffer.Length());

		bz = new CBZ();
		if ( !bz->Compress(&iba,m_pBZShareBuffer) )
		{
			delete m_pBZShareBuffer;
			m_pBZShareBuffer = 0;
			printf("[ERROR] bz2 compression failed\n");
		}
		delete bz;
	}

	Thread.UnLock();

	// save the list
	SaveDCMyList();
}

/** */
bool CConfig::AddHubProfile( DCConfigHubProfile * p )
{
	bool err = FALSE;
	DCConfigHubProfile * pConfigHubProfile;

	if ( !p )
	{
		return err;
	}

	Thread.Lock();

	pConfigHubProfile = 0;

	if ( pHubProfileList->Get( p->sName, (CObject*&)pConfigHubProfile ) == 0 )
	{
		// update
		pConfigHubProfile->sPassword    = p->sPassword;
		pConfigHubProfile->bAutoConnect = p->bAutoConnect;
		err = TRUE;
	}
	else
	{
		// create new entry
		pConfigHubProfile = new DCConfigHubProfile(p);
		pHubProfileList->Add(p->sName,pConfigHubProfile);
		err = TRUE;
	}

	Thread.UnLock();

	return err;
}

/** */
bool CConfig::DelHubProfile( CString name )
{
	Thread.Lock();

	pHubProfileList->Del(name);

	Thread.UnLock();

	return TRUE;
}

/** */
bool CConfig::GetHubProfile( CString name, DCConfigHubProfile * p )
{
	bool err = FALSE;
	DCConfigHubProfile * pConfigHubProfile;

	Thread.Lock();

	if ( pHubProfileList->Get( name, (CObject*&)pConfigHubProfile ) == 0 )
	{
		p->sName        = pConfigHubProfile->sName;
		p->sPassword    = pConfigHubProfile->sPassword;
		p->bAutoConnect = pConfigHubProfile->bAutoConnect;
		err = TRUE;
	}

	Thread.UnLock();

	return err;
}

/** */
bool CConfig::GetHubProfileList( CStringList * list )
{
	DCConfigHubProfile * pConfigHubProfile, *p;
	bool err = FALSE;

	if ( !list )
	{
		return err;
	}

	Thread.Lock();

	err = TRUE;

	pConfigHubProfile = 0;
	while( pHubProfileList->Next((CObject*&)pConfigHubProfile) )
	{
		p = new DCConfigHubProfile(pConfigHubProfile);

		list->Add(p->sName,p);
	}

	Thread.UnLock();

	return err;
}

/** */
bool CConfig::SaveHubProfile()
{
	bool err = FALSE;
	CString s;
	xmlDocPtr doc;
	xmlNodePtr node;
	CObject * Object;
	DCConfigHubProfile * pConfigHubProfile;
	CXml * xml;

	Thread.Lock();

	xml = new CXml();
	doc = xmlNewDoc((const xmlChar*)"1.0");

	doc->children = xmlNewDocNode(doc,0,(const xmlChar*)XML_DCPROF_CONFIG,0);

	Object = 0;
	while(pHubProfileList->Next((CObject*&)Object))
	{
		pConfigHubProfile = (DCConfigHubProfile*)Object;

		node = xmlNewChild( doc->children, 0, (const xmlChar*)XML_PROFILE, 0 );

		xmlNewChild( node, 0, (const xmlChar*)XML_NAME, (const xmlChar*) xml->ToUTF8(pConfigHubProfile->sName).Data());
		xmlNewChild( node, 0, (const xmlChar*)XML_PASSWORD, (const xmlChar*) xml->ToUTF8(pConfigHubProfile->sPassword).Data());
		xml->xmlNewBoolChild( node, 0, (const xmlChar*)XML_AUTO_CONNECT, pConfigHubProfile->bAutoConnect );
	}

	s = sConfigPath + DCPROF_CONFIG;

	if ( ! (xmlSaveFormatFile(s.Data(),doc,1) == -1) )
	{
		err = TRUE;
	}

	xmlFreeDoc(doc);
	delete xml;

	Thread.UnLock();

	return err;
}

/** */
bool CConfig::LoadHubProfile()
{
	bool err = TRUE;
	CString s;
	DCConfigHubProfile * pConfigHubProfile;
	CXml *xml;
	xmlNodePtr n1,n2,node;

	Thread.Lock();

	xml = new CXml();

	s = sConfigPath + DCPROF_CONFIG;

	if ( xml->ParseFile(s) == TRUE )
	{
		for(node=xml->doc()->children;node!=0;node=node->next)
		{
			if ( xml->name(node) == XML_DCPROF_CONFIG )
			{
				for(n1=node->xmlChildrenNode;n1!=0;n1=n1->next)
				{
					if ( xml->name(n1) == XML_PROFILE )
					{
						pConfigHubProfile = new DCConfigHubProfile();

						for(n2=n1->xmlChildrenNode;n2!=0;n2=n2->next)
						{
							if ( xml->name(n2) == XML_NAME )
								pConfigHubProfile->sName = xml->content(n2);
							else if ( xml->name(n2) == XML_PASSWORD )
								pConfigHubProfile->sPassword = xml->content(n2);
							else if ( xml->name(n2) == XML_AUTO_CONNECT )
								pConfigHubProfile->bAutoConnect = xml->getBoolChild(n2);
						}

						if ( pConfigHubProfile->sName != "" )
							pHubProfileList->Add(pConfigHubProfile->sName,pConfigHubProfile);
						else
							delete pConfigHubProfile;
					}
				}
			}
		}
	}

	delete xml;

	Thread.UnLock();

	return err;
}

/** */
void CConfig::GetSearchHistory( CList<CString> * list )
{
	CString *ps;

	if ( !list )
	{
		return;
	}

	Thread.Lock();

	ps = 0;

	while ( (ps=pSearchHistory->Next(ps)) != 0 )
	{
		list->Add( new CString(*ps) );
	}

	Thread.UnLock();
}

/** */
void CConfig::AddSearchHistory( CString s )
{
	CString *ps;

	if ( s == "" )
	{
		return;
	}

	Thread.Lock();

	ps = 0;

	while ( (ps=pSearchHistory->Next(ps)) != 0 )
	{
		if ( *ps == s )
		{
			pSearchHistory->Del(ps);
			ps = 0;
			break;
		}
	}

	// not found
	if ( ps == 0 )
	{
		if ( pSearchHistory->Count() == 10 )
		{
			// delete first entry
			ps = pSearchHistory->Next(0);
			pSearchHistory->Del(ps);
		}

		pSearchHistory->Add( new CString(s) );
	}

	Thread.UnLock();

	SaveDCLib();
}
